## Regular Commands

| **Command** | **Description** |
|-------------|-----------------|
| `:TOhtml` | Alias for tohtml |
| `:action` | Execute a bim action |
| `:buffers` | Show the open buffers |
| `:call` | Call a function |
| `:checkprop` | Check a property value; returns the inverse of the property |
| `:clearyank` | Clear the yank buffer |
| `:colorgutter` | Show or change status of gutter colorization for unsaved modifications |
| `:colorscheme` | Alias for theme |
| `:crnl` | Show or set the line ending mode |
| `:cursorcolumn` | Show the visual column offset of the cursor. |
| `:e` | Open a file |
| `:git` | Show or change status of git integration |
| `:global.autohidetabs` | Whether to show the tab bar when there is only one tab |
| `:global.git` | Show or change the default status of git integration |
| `:global.numbers` | Set whether numbers are displayed by default |
| `:global.statusbar` | Show or set whether to display the statusbar |
| `:help` | Show help text. |
| `:history` | Display command history |
| `:hlcurrent` | Show or set the configuration option to highlight the current line |
| `:hlparen` | Show or set the configuration option to highlight matching braces |
| `:horizontalscrolling` | Set the horizontal scrolling mode |
| `:indent` | Enable smart indentation |
| `:keyname` | Press and key and get its name. |
| `:listfunctions` | List functions |
| `:mapkey` | Map a key to an action. |
| `:maxcolumn` | Highlight past the given column to indicate maximum desired line length |
| `:noh` | Clear search term |
| `:noindent` | Disable smart indentation |
| `:numbers` | Show or set the display of line numbers |
| `:padding` | Show or set cursor padding when scrolling vertically |
| `:q` | Close buffer |
| `:q!` | Force close buffer |
| `:qa` | Try to close all buffers |
| `:qa!` | Force exit |
| `:qall` | Alias for qa |
| `:quirk` | Handle quirks based on environment variables |
| `:recalc` | Recalculate syntax for the entire file. |
| `:relativenumbers` | Show or set the display of relative line numbers |
| `:rundir` | Run scripts from a directory, in unspecified order |
| `:runscript` | Run a script file |
| `:setcap` | Enable or disable quirks/features. |
| `:setcolor` | Set colorscheme colors |
| `:showfunction` | Show the commands in a function |
| `:smartcase` | Show or set the status of the smartcase search option |
| `:smartcomplete` | Enable autocompletion while typing |
| `:spaceindicator` | Set the space indicator |
| `:spaces` | Use spaces for indentation |
| `:split` | Split the current view. |
| `:splitpercent` | Display or change view split |
| `:syntax` | Show or set the active syntax highlighter |
| `:tabindicator` | Set the tab indicator |
| `:tabn` | Next tab |
| `:tabnew` | Open a new tab |
| `:tabp` | Previous tab |
| `:tabs` | Use tabs for indentation |
| `:tabstop` | Show or set the tabstop (width of an indentation unit) |
| `:theme` | Set color theme |
| `:tohtml` | Convert the document to an HTML representation with syntax highlighting. |
| `:trycall` | Call a function but return quietly if it fails |
| `:unsplit` | Show only one buffer on screen |
| `:version` | Show version information. |
| `:w` | Write a file |
| `:whatis` | Describe actions bound to a key in different modes. |
| `:wq` | Write and close buffer |
| `:wrapsearch` | Enable search wrapping around from top or bottom |

## Prefix Commands

| **Command** | **Description** |
|-------------|-----------------|
| `:s...` | Perform a replacement over selected lines |
| `:`(backtick)`...` | Executes Python commands. |
| `:%s...` | Perform a replacement over the entire file. |
| `:!...` | Executes shell commands. |

